summaryrefslogtreecommitdiff
path: root/runtests.sh
diff options
context:
space:
mode:
authorMartin Pool <mbp@samba.org>2002-01-11 07:11:23 +0000
committerMartin Pool <mbp@samba.org>2002-01-11 07:11:23 +0000
commitcf72f20426c4b6c9c2467185f85e09e0028d39b6 (patch)
treea0ea8a9e68b77d8481d94fb7f7a09e0e582d2617 /runtests.sh
parentd479210cee5b19beba32e20dc66bf141f3fee56d (diff)
downloadrsync-cf72f20426c4b6c9c2467185f85e09e0028d39b6.tar.gz
Improved test framework and test for hardlink handling
Diffstat (limited to 'runtests.sh')
-rwxr-xr-xruntests.sh65
1 files changed, 40 insertions, 25 deletions
diff --git a/runtests.sh b/runtests.sh
index ab6f77a5..5d3af1b1 100755
--- a/runtests.sh
+++ b/runtests.sh
@@ -1,6 +1,6 @@
#! /bin/sh
-# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
+# Copyright (C) 2001, 2002 by Martin Pool <mbp@samba.org>
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version
@@ -160,16 +160,25 @@ missing=0
passed=0
failed=0
-scratchdir="`pwd`"/testtmp
-echo " scratchdir=$scratchdir"
+# Prefix for scratch directory. We create separate directories for
+# each test case, so that they can be left behind in case of failure
+# to aid investigation.
+scratchbase="`pwd`"/testtmp
+echo " scratchbase=$scratchbase"
suitedir="$srcdir/testsuite"
export scratchdir suitedir
-clean_scratch() {
+prep_scratch() {
[ -d "$scratchdir" ] && rm -rf "$scratchdir"
mkdir "$scratchdir"
+ return 0
+}
+
+discard_scratch() {
+ [ -d "$scratchdir" ] && rm -rf "$scratchdir"
+ return 0
}
if [ "x$whichtests" = x ]
@@ -179,32 +188,38 @@ fi
for testscript in $suitedir/$whichtests
do
- testbase=`echo $testscript | sed 's!.*/!!'`
+ testbase=`echo $testscript | sed 's!.*/!!' | sed -e 's/.test\$//'`
+ scratchdir="$scratchbase.$testbase"
echo "----- $testbase starting"
- clean_scratch
+ prep_scratch
- if sh $RUNSHFLAGS "$testscript" >"$scratchdir/test.log" 2>&1
- then
+ set +e
+ sh $RUNSHFLAGS "$testscript" >"$scratchdir/test.log" 2>&1
+ result=$?
+ set -e
+
+ case $result in
+ 0)
echo "----- $testbase completed successfully"
passed=`expr $passed + 1`
- else
- case $? in
- 77)
- echo "----- $testbase skipped"
- skipped=`expr $skipped + 1`
- ;;
- *)
- echo "----- $testbase failed: log follows"
- cat "$scratchdir/test.log"
- echo "----- $testbase log ends"
- failed=`expr $failed + 1`
- if [ "x$nopersist" = "xyes" ]
- then
- exit 1
- fi
- esac
- fi
+ discard_scratch
+ ;;
+ 77)
+ echo "----- $testbase skipped"
+ skipped=`expr $skipped + 1`
+ discard_scratch
+ ;;
+ *)
+ echo "----- $testbase failed: log follows"
+ cat "$scratchdir/test.log"
+ echo "----- $testbase log ends"
+ failed=`expr $failed + 1`
+ if [ "x$nopersist" = "xyes" ]
+ then
+ exit 1
+ fi
+ esac
done
echo '------------------------------------------------------------'